#! /usr/bin/python

"""
This script wraps a test/development corpus in sgm format to be used by scorers.

Current version: 1.1
        - id number is now wrapped in quotations to comply with mteval v13a
"""

import sys, optparse

parser = optparse.OptionParser(usage="%prog <INPUT FILE> <SET TYPE> <SET ID> [--sysid SYSTEM ID] [--srclang SOURCE LANGUAGE] [--trglang TARGET LANGUAGE] [--docid DOCUMENT ID]\r\nWraps a test/development corpus in sgm format to be used by scorers.", version="%prog 1.0")

parser.add_option("--sysid", help="system ID", metavar="SYSTEM ID", dest="sysID", action="store")
parser.add_option("--srclang", help="source language (e.g. en)", metavar="SOURCE LANGUAGE", dest="srcLang", action="store")
parser.add_option("--trglang", help="target language (e.g. fr)", metavar="TARGET LANGUAGE", dest="trgLang", action="store")
parser.add_option("--docid", help="document ID", metavar="DOCUMENT ID", dest="docID", action="store")

(opts, posargs) = parser.parse_args()

if len(posargs) < 3:
 parser.error("Incorrect number of arguments! At least 3 arguments are required.")

inFileName = posargs[0]
setType = posargs[1]
setID = posargs[2]

# processing options

srcLangStr = ''
trgLangStr = ''
docIDStr = ''
sysIDStr = ''

if opts.srcLang != None:
 srcLangStr = ' srclang="' + opts.srcLang + '"'

if opts.trgLang != None:
 trgLangStr = ' trglang="' + opts.trgLang + '"'

if opts.docID != None:
 docIDStr = 'docid="' + opts.docID + '"'
else:
 docIDStr = 'docid="' + setID + '"'

if opts.sysID != None:
 sysIDStr = ' sysid="' + opts.sysID + '"'

# writing the file header

print '<' + setType + ' setid="' + setID + '"' + srcLangStr + trgLangStr + '>'
print '<DOC ' + docIDStr + sysIDStr + '>'

# openning the input file

try:
 inFile  = open(inFileName, 'r')
except IOError:
  print 'Can\'t open input file: ' + inFileName
  sys.exit(2)

# wrapping lines 

cntr = 1
for line in inFile:
 print '<seg id="' + str(cntr) + '"> ' + line.rstrip('\r\n')+ ' </seg>'
 cntr += 1

# writing the file footer 

print '</DOC>'
print '</' + setType + '>'

#end of script
