#! /usr/bin/python

"""	
	This script extracts summary scores from one or many evalb (parser 
	evaluation) files and output in the requested format.
	
	Version: 1.0
	- Output in CSV format
	
"""

import sys, optparse, evalbproc, os


##======================================================================
## main
def main(argv=None):
	if argv is None:
		argv = sys.argv
	
	parser = optparse.OptionParser(usage="%prog <EVALB SCORE FILE [<EVALB SCORE FILE> [..]] >" + 
                                      "\nExtracts scores from one or many evalb (parser evaluation) files and output in the requested format", version="%prog 1.0")
	
	
	(opts, posArgs) = parser.parse_args()
	
	# processing arguments
	
	vlEvalbFiles = posArgs[0:]
	vEvalbFileNum = len(vlEvalbFiles) 
	
	if vEvalbFileNum < 1:
		parser.error("At least 1 evalb files are required")
	
	
	# extrating scores
	vlScores = []
	for vEvalbFileName in vlEvalbFiles:
		vlScores.append(evalbproc.extractDocumentScores(vEvalbFileName))
	
	
	# printing output
	
	# file (probably parser-related) names
	print "Parser/grammar," + ','.join([os.path.basename(vFile) for vFile in vlEvalbFiles])
	
	
	# Recalls
	print "Recall," + ','.join([str(score.recall) for score in vlScores])
	
	# Precisions
	print "Precision," + ','.join([str(score.precision) for score in vlScores])
	 
	# FMeasures
	print "FMeasure," + ','.join([str(score.fscore) for score in vlScores])
	 
	# Tagging accuracies
	print "Tagging accuracy," + ','.join([str(score.tagacc) for score in vlScores])
	
	

##======================================================================
## calling main
if __name__ == "__main__":
 sys.exit(main())
 
