#! /usr/bin/python

## This script gets any number of input evalb parse score file and mergs
## them into one output evalb file.
##
## Current version: 1.0
##
## Currently, summarization of scores at the end of evalb files are ignored.
##

from operator import itemgetter
import sys, optparse, evalbproc

##======================================================================
## main
def main(argv=None):
 if argv is None:
  argv = sys.argv
 
 parser = optparse.OptionParser(usage="%prog <EVALB SCORE FILE [<EVALB SCORE FILE> [..]] >" + 
                                      "\nMergs any number of input evalb parse score files into one output evalb file", version="%prog 1.0")


 (opts, posArgs) = parser.parse_args()
 
 # processing arguments
 
 vEvalbFileNum = len(posArgs) 

 if vEvalbFileNum < 2:
  parser.error("At least 2 evalb files are required")
  
 
 # printing header (copied from a sample evalb file)
 print "  Sent.                        Matched  Bracket   Cross        Correct Tag  "
 print " ID  Len.  Stat. Recal  Prec.  Bracket gold test Bracket Words  Tags Accracy"
 print "============================================================================"

 # extrating sentence scores
 vlScoreLines = []
 for vEvalbFileName in posArgs:
  vlScoreLines += evalbproc.extractSentenceScoreLines(vEvalbFileName, False)
  
 # printing output
 vSentenceCntr = 1
 for vScoreLine in vlScoreLines:
  print str.rjust(str(vSentenceCntr), 4) + str.rjust(vScoreLine.scores, 72)
  vSentenceCntr += 1
 
 
 # printing footer divider 
 print "============================================================================"


##======================================================================
## calling main
if __name__ == "__main__":
 sys.exit(main())
 
